import { PresenceChannel } from 'laravel-echo';
import WavePrivateChannel from './wave-private-channel';
export default class WavePresenceChannel extends WavePrivateChannel implements PresenceChannel {
    private joined;
    private joinRequest;
    private csrfToken;
    private users;
    private hereCallbacks;
    private unloadCallback;
    constructor(connection: any, name: any, options: any);
    subscribe(): void;
    here(callback: Function): WavePresenceChannel;
    /**
     * Listen for someone joining the channel.
     */
    joining(callback: Function): WavePresenceChannel;
    /**
     * Listen for someone leaving the channel.
     */
    leaving(callback: Function): WavePresenceChannel;
    unsubscribeBeacon(): void;
    unsubscribe(): void;
}
