import { EventSourceConnection } from "../EventSourceConnection";
import { Options } from '../echo-broadcaster/wave-connector';
export declare function getXsrfTokenFromCookie(): string;
export declare function prepareHeaders(options?: Options): {};
export default function request(connection: EventSourceConnection, keepAlive?: boolean): {
    get: (route: string, options: Options, data?: object) => Promise<Response>;
    post: (route: string, options: Options, data?: object) => Promise<Response>;
    put: (route: string, options: Options, data?: object) => Promise<Response>;
    delete: (route: string, options: Options, data?: object) => Promise<Response>;
};
export declare function beacon(connectionId: string, csrfToken: string, route: string, data?: object, method?: string): void;
