'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var fetchEventSource = require('@qruto/fetch-event-source');
var laravelEcho = require('laravel-echo');

function _iterableToArrayLimit(r, l) {
  var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
  if (null != t) {
    var e,
      n,
      i,
      u,
      a = [],
      f = !0,
      o = !1;
    try {
      if (i = (t = t.call(r)).next, 0 === l) {
        if (Object(t) !== t) return;
        f = !1;
      } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0);
    } catch (r) {
      o = !0, n = r;
    } finally {
      try {
        if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return;
      } finally {
        if (o) throw n;
      }
    }
    return a;
  }
}
function _regeneratorRuntime() {
  _regeneratorRuntime = function () {
    return e;
  };
  var t,
    e = {},
    r = Object.prototype,
    n = r.hasOwnProperty,
    o = Object.defineProperty || function (t, e, r) {
      t[e] = r.value;
    },
    i = "function" == typeof Symbol ? Symbol : {},
    a = i.iterator || "@@iterator",
    c = i.asyncIterator || "@@asyncIterator",
    u = i.toStringTag || "@@toStringTag";
  function define(t, e, r) {
    return Object.defineProperty(t, e, {
      value: r,
      enumerable: !0,
      configurable: !0,
      writable: !0
    }), t[e];
  }
  try {
    define({}, "");
  } catch (t) {
    define = function (t, e, r) {
      return t[e] = r;
    };
  }
  function wrap(t, e, r, n) {
    var i = e && e.prototype instanceof Generator ? e : Generator,
      a = Object.create(i.prototype),
      c = new Context(n || []);
    return o(a, "_invoke", {
      value: makeInvokeMethod(t, r, c)
    }), a;
  }
  function tryCatch(t, e, r) {
    try {
      return {
        type: "normal",
        arg: t.call(e, r)
      };
    } catch (t) {
      return {
        type: "throw",
        arg: t
      };
    }
  }
  e.wrap = wrap;
  var h = "suspendedStart",
    l = "suspendedYield",
    f = "executing",
    s = "completed",
    y = {};
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}
  var p = {};
  define(p, a, function () {
    return this;
  });
  var d = Object.getPrototypeOf,
    v = d && d(d(values([])));
  v && v !== r && n.call(v, a) && (p = v);
  var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p);
  function defineIteratorMethods(t) {
    ["next", "throw", "return"].forEach(function (e) {
      define(t, e, function (t) {
        return this._invoke(e, t);
      });
    });
  }
  function AsyncIterator(t, e) {
    function invoke(r, o, i, a) {
      var c = tryCatch(t[r], t, o);
      if ("throw" !== c.type) {
        var u = c.arg,
          h = u.value;
        return h && "object" == typeof h && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) {
          invoke("next", t, i, a);
        }, function (t) {
          invoke("throw", t, i, a);
        }) : e.resolve(h).then(function (t) {
          u.value = t, i(u);
        }, function (t) {
          return invoke("throw", t, i, a);
        });
      }
      a(c.arg);
    }
    var r;
    o(this, "_invoke", {
      value: function (t, n) {
        function callInvokeWithMethodAndArg() {
          return new e(function (e, r) {
            invoke(t, n, e, r);
          });
        }
        return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      }
    });
  }
  function makeInvokeMethod(e, r, n) {
    var o = h;
    return function (i, a) {
      if (o === f) throw new Error("Generator is already running");
      if (o === s) {
        if ("throw" === i) throw a;
        return {
          value: t,
          done: !0
        };
      }
      for (n.method = i, n.arg = a;;) {
        var c = n.delegate;
        if (c) {
          var u = maybeInvokeDelegate(c, n);
          if (u) {
            if (u === y) continue;
            return u;
          }
        }
        if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) {
          if (o === h) throw o = s, n.arg;
          n.dispatchException(n.arg);
        } else "return" === n.method && n.abrupt("return", n.arg);
        o = f;
        var p = tryCatch(e, r, n);
        if ("normal" === p.type) {
          if (o = n.done ? s : l, p.arg === y) continue;
          return {
            value: p.arg,
            done: n.done
          };
        }
        "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg);
      }
    };
  }
  function maybeInvokeDelegate(e, r) {
    var n = r.method,
      o = e.iterator[n];
    if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y;
    var i = tryCatch(o, e.iterator, r.arg);
    if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y;
    var a = i.arg;
    return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y);
  }
  function pushTryEntry(t) {
    var e = {
      tryLoc: t[0]
    };
    1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e);
  }
  function resetTryEntry(t) {
    var e = t.completion || {};
    e.type = "normal", delete e.arg, t.completion = e;
  }
  function Context(t) {
    this.tryEntries = [{
      tryLoc: "root"
    }], t.forEach(pushTryEntry, this), this.reset(!0);
  }
  function values(e) {
    if (e || "" === e) {
      var r = e[a];
      if (r) return r.call(e);
      if ("function" == typeof e.next) return e;
      if (!isNaN(e.length)) {
        var o = -1,
          i = function next() {
            for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next;
            return next.value = t, next.done = !0, next;
          };
        return i.next = i;
      }
    }
    throw new TypeError(typeof e + " is not iterable");
  }
  return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", {
    value: GeneratorFunctionPrototype,
    configurable: !0
  }), o(GeneratorFunctionPrototype, "constructor", {
    value: GeneratorFunction,
    configurable: !0
  }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) {
    var e = "function" == typeof t && t.constructor;
    return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name));
  }, e.mark = function (t) {
    return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t;
  }, e.awrap = function (t) {
    return {
      __await: t
    };
  }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () {
    return this;
  }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) {
    void 0 === i && (i = Promise);
    var a = new AsyncIterator(wrap(t, r, n, o), i);
    return e.isGeneratorFunction(r) ? a : a.next().then(function (t) {
      return t.done ? t.value : a.next();
    });
  }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () {
    return this;
  }), define(g, "toString", function () {
    return "[object Generator]";
  }), e.keys = function (t) {
    var e = Object(t),
      r = [];
    for (var n in e) r.push(n);
    return r.reverse(), function next() {
      for (; r.length;) {
        var t = r.pop();
        if (t in e) return next.value = t, next.done = !1, next;
      }
      return next.done = !0, next;
    };
  }, e.values = values, Context.prototype = {
    constructor: Context,
    reset: function (e) {
      if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t);
    },
    stop: function () {
      this.done = !0;
      var t = this.tryEntries[0].completion;
      if ("throw" === t.type) throw t.arg;
      return this.rval;
    },
    dispatchException: function (e) {
      if (this.done) throw e;
      var r = this;
      function handle(n, o) {
        return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o;
      }
      for (var o = this.tryEntries.length - 1; o >= 0; --o) {
        var i = this.tryEntries[o],
          a = i.completion;
        if ("root" === i.tryLoc) return handle("end");
        if (i.tryLoc <= this.prev) {
          var c = n.call(i, "catchLoc"),
            u = n.call(i, "finallyLoc");
          if (c && u) {
            if (this.prev < i.catchLoc) return handle(i.catchLoc, !0);
            if (this.prev < i.finallyLoc) return handle(i.finallyLoc);
          } else if (c) {
            if (this.prev < i.catchLoc) return handle(i.catchLoc, !0);
          } else {
            if (!u) throw new Error("try statement without catch or finally");
            if (this.prev < i.finallyLoc) return handle(i.finallyLoc);
          }
        }
      }
    },
    abrupt: function (t, e) {
      for (var r = this.tryEntries.length - 1; r >= 0; --r) {
        var o = this.tryEntries[r];
        if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) {
          var i = o;
          break;
        }
      }
      i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null);
      var a = i ? i.completion : {};
      return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a);
    },
    complete: function (t, e) {
      if ("throw" === t.type) throw t.arg;
      return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y;
    },
    finish: function (t) {
      for (var e = this.tryEntries.length - 1; e >= 0; --e) {
        var r = this.tryEntries[e];
        if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y;
      }
    },
    catch: function (t) {
      for (var e = this.tryEntries.length - 1; e >= 0; --e) {
        var r = this.tryEntries[e];
        if (r.tryLoc === t) {
          var n = r.completion;
          if ("throw" === n.type) {
            var o = n.arg;
            resetTryEntry(r);
          }
          return o;
        }
      }
      throw new Error("illegal catch attempt");
    },
    delegateYield: function (e, r, n) {
      return this.delegate = {
        iterator: values(e),
        resultName: r,
        nextLoc: n
      }, "next" === this.method && (this.arg = t), y;
    }
  }, e;
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r || "default");
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : String(i);
}
function _typeof(o) {
  "@babel/helpers - typeof";

  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) {
    return typeof o;
  } : function (o) {
    return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o;
  }, _typeof(o);
}
function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}
function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor);
  }
}
function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  Object.defineProperty(Constructor, "prototype", {
    writable: false
  });
  return Constructor;
}
function _defineProperty(obj, key, value) {
  key = _toPropertyKey(key);
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  Object.defineProperty(subClass, "prototype", {
    writable: false
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}
function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}
function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };
  return _setPrototypeOf(o, p);
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
function _construct(Parent, args, Class) {
  if (_isNativeReflectConstruct()) {
    _construct = Reflect.construct.bind();
  } else {
    _construct = function _construct(Parent, args, Class) {
      var a = [null];
      a.push.apply(a, args);
      var Constructor = Function.bind.apply(Parent, a);
      var instance = new Constructor();
      if (Class) _setPrototypeOf(instance, Class.prototype);
      return instance;
    };
  }
  return _construct.apply(null, arguments);
}
function _isNativeFunction(fn) {
  try {
    return Function.toString.call(fn).indexOf("[native code]") !== -1;
  } catch (e) {
    return typeof fn === "function";
  }
}
function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? new Map() : undefined;
  _wrapNativeSuper = function _wrapNativeSuper(Class) {
    if (Class === null || !_isNativeFunction(Class)) return Class;
    if (typeof Class !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }
    if (typeof _cache !== "undefined") {
      if (_cache.has(Class)) return _cache.get(Class);
      _cache.set(Class, Wrapper);
    }
    function Wrapper() {
      return _construct(Class, arguments, _getPrototypeOf(this).constructor);
    }
    Wrapper.prototype = Object.create(Class.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return _setPrototypeOf(Wrapper, Class);
  };
  return _wrapNativeSuper(Class);
}
function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }
  return self;
}
function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  } else if (call !== void 0) {
    throw new TypeError("Derived constructors may only return object or undefined");
  }
  return _assertThisInitialized(self);
}
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = _getPrototypeOf(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf(this).constructor;
      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return _possibleConstructorReturn(this, result);
  };
}
function _superPropBase(object, property) {
  while (!Object.prototype.hasOwnProperty.call(object, property)) {
    object = _getPrototypeOf(object);
    if (object === null) break;
  }
  return object;
}
function _get() {
  if (typeof Reflect !== "undefined" && Reflect.get) {
    _get = Reflect.get.bind();
  } else {
    _get = function _get(target, property, receiver) {
      var base = _superPropBase(target, property);
      if (!base) return;
      var desc = Object.getOwnPropertyDescriptor(base, property);
      if (desc.get) {
        return desc.get.call(arguments.length < 3 ? target : receiver);
      }
      return desc.value;
    };
  }
  return _get.apply(this, arguments);
}
function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}
function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
    var e = new Error(message);
    return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
};

function getXsrfTokenFromCookie() {
  if (typeof document !== 'undefined') {
    var match = document.cookie.match(new RegExp('(^|;\\s*)(XSRF-TOKEN)=([^;]*)'));
    return match ? decodeURIComponent(match[3]) : null;
  }
  return '';
}
function prepareHeaders(options) {
  var _a, _b, _c, _d, _e, _f;
  var authHeaders = (_b = (_a = options === null || options === void 0 ? void 0 : options.auth) === null || _a === void 0 ? void 0 : _a.headers) !== null && _b !== void 0 ? _b : {};
  var csrfTokenHeader = {};
  if (options.csrfToken) {
    csrfTokenHeader['X-CSRF-TOKEN'] = options.csrfToken;
  } else if (typeof authHeaders['X-CSRF-TOKEN'] !== 'undefined') {
    csrfTokenHeader['X-CSRF-TOKEN'] = authHeaders['X-CSRF-TOKEN'];
  } else {
    var token = getXsrfTokenFromCookie();
    if (token) {
      csrfTokenHeader['X-XSRF-TOKEN'] = token;
    }
  }
  var formattedHeaders = {};
  var requestHeaders = (_d = (_c = options === null || options === void 0 ? void 0 : options.request) === null || _c === void 0 ? void 0 : _c.headers) !== null && _d !== void 0 ? _d : {};
  if (typeof requestHeaders !== 'undefined') {
    if (requestHeaders instanceof Headers) {
      requestHeaders.forEach(function (value, key) {
        formattedHeaders[key] = value;
      });
    } else if (Array.isArray(requestHeaders)) {
      formattedHeaders = Object.fromEntries(requestHeaders);
    } else {
      formattedHeaders = requestHeaders;
    }
  }
  return _extends(_extends(_extends({}, (_f = (_e = options === null || options === void 0 ? void 0 : options.auth) === null || _e === void 0 ? void 0 : _e.headers) !== null && _f !== void 0 ? _f : {}), csrfTokenHeader), formattedHeaders);
}
function prepareRequest(connectionId, method, options, data) {
  var keepAlive = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
  var headers = _extends({
    'Content-Type': 'application/json',
    'Accept': 'application/json',
    'X-Socket-Id': connectionId
  }, prepareHeaders(options));
  return _extends(_extends(_extends(_extends({
    method: method
  }, options.request), {
    headers: headers
  }), typeof data === 'undefined' || method === 'GET' ? {} : {
    body: JSON.stringify(data)
  }), {
    keepalive: keepAlive
  });
}
function request(connection) {
  var keepAlive = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
  function create(method, route, options, data) {
    var uri = route;
    if (method === 'GET' && typeof data !== 'undefined') {
      var params = new URLSearchParams();
      for (var _i = 0, _Object$entries = Object.entries(data); _i < _Object$entries.length; _i++) {
        var _Object$entries$_i = _slicedToArray(_Object$entries[_i], 2),
          key = _Object$entries$_i[0],
          value = _Object$entries$_i[1];
        params.append(key, value);
      }
      uri += '?' + params.toString();
    }
    var fetchRequest = function fetchRequest(connectionId) {
      return window.fetch(uri, prepareRequest(connectionId, method, options, data, keepAlive));
    };
    return typeof connection.getId() === 'undefined' ? new Promise(function (resolve) {
      return connection.once('connected', function (id) {
        return resolve(fetchRequest(id));
      });
    }) : fetchRequest(connection.getId());
  }
  var factory = function factory(method) {
    return function (route, options, data) {
      return create(method, route, options, data);
    };
  };
  return {
    get: factory('GET'),
    post: factory('POST'),
    put: factory('PUT'),
    "delete": factory('DELETE')
  };
}
function beacon(connectionId, csrfToken, route, data) {
  var method = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 'POST';
  navigator.sendBeacon(route, new Blob([JSON.stringify(_extends(data !== null && data !== void 0 ? data : {}, {
    socket_id: connectionId,
    _token: csrfToken,
    _method: method
  }))], {
    type: 'application/json'
  }));
}

var EventEmitter = /*#__PURE__*/function () {
  function EventEmitter() {
    _classCallCheck(this, EventEmitter);
    this.listeners = {};
  }
  _createClass(EventEmitter, [{
    key: "once",
    value: function once(event, listener) {
      var _this = this;
      var onceListener = function onceListener() {
        listener.apply(void 0, arguments);
        _this.off(event, onceListener);
      };
      this.on(event, onceListener);
    }
  }, {
    key: "on",
    value: function on(event, listener) {
      var _a;
      if (!this.listeners[event]) {
        this.listeners[event] = [];
      }
      (_a = this.listeners[event]) === null || _a === void 0 ? void 0 : _a.push(listener);
    }
  }, {
    key: "emit",
    value: function emit(event) {
      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }
      var _a;
      (_a = this.listeners[event]) === null || _a === void 0 ? void 0 : _a.slice().forEach(function (listener) {
        return listener.apply(void 0, args);
      });
    }
  }, {
    key: "off",
    value: function off(event, listener) {
      var listeners = this.listeners[event];
      if (!listeners) return;
      var index = listeners.indexOf(listener);
      if (index > -1) {
        listeners.splice(index, 1);
      }
    }
  }]);
  return EventEmitter;
}();

var RetriableError = /*#__PURE__*/function (_Error) {
  _inherits(RetriableError, _Error);
  var _super = _createSuper(RetriableError);
  function RetriableError() {
    _classCallCheck(this, RetriableError);
    return _super.apply(this, arguments);
  }
  return _createClass(RetriableError);
}( /*#__PURE__*/_wrapNativeSuper(Error));
var FatalError = /*#__PURE__*/function (_Error2) {
  _inherits(FatalError, _Error2);
  var _super2 = _createSuper(FatalError);
  function FatalError() {
    _classCallCheck(this, FatalError);
    return _super2.apply(this, arguments);
  }
  return _createClass(FatalError);
}( /*#__PURE__*/_wrapNativeSuper(Error));
var EventSourceConnection = /*#__PURE__*/function () {
  function EventSourceConnection(endpoint, options) {
    var reconnect = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
    _classCallCheck(this, EventSourceConnection);
    this.listeners = {};
    this.reconnecting = false;
    this.bus = new EventEmitter();
    options = _extends({
      pauseInactive: false,
      debug: false
    }, options);
    this.ctrl = new AbortController();
    var headers = _extends({
      'Cache-Control': 'no-cache',
      'Pragma': 'no-cache',
      'Connection': 'keep-alive'
    }, prepareHeaders(options));
    this.sourcePromise = this.create(endpoint, options, headers, reconnect);
  }
  _createClass(EventSourceConnection, [{
    key: "create",
    value: function create(endpoint, options, headers, reconnect) {
      var _this = this;
      return fetchEventSource.fetchEventSource(endpoint, _extends(_extends({
        signal: this.ctrl.signal
      }, _extends(_extends({}, options.request), {
        headers: headers
      })), {
        openWhenHidden: typeof options.pauseInactive === 'undefined' ? true : !options.pauseInactive,
        onopen: function onopen(response) {
          return __awaiter(_this, void 0, void 0, /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
            return _regeneratorRuntime().wrap(function _callee$(_context) {
              while (1) switch (_context.prev = _context.next) {
                case 0:
                  this.bus.emit('open', response);
                  if (!(response.ok && response.headers.get('content-type').startsWith('text/event-stream'))) {
                    _context.next = 5;
                    break;
                  }
                  return _context.abrupt("return");
                case 5:
                  if (!(response.status >= 400 && response.status < 500 && response.status !== 429)) {
                    _context.next = 9;
                    break;
                  }
                  throw new FatalError();
                case 9:
                  throw new RetriableError();
                case 10:
                case "end":
                  return _context.stop();
              }
            }, _callee, this);
          }));
        },
        onmessage: function onmessage(message) {
          var _a;
          // if the server emits an error message, throw an exception
          // so it gets handled by the onerror callback below:
          if (options.debug) {
            debugEvent(message);
          }
          // TODO: possibly change name of this event
          if (message.event === 'general.connected') {
            _this.id = message.data;
            _this.reconnecting = false;
            headers['X-Socket-Id'] = _this.id;
            _this.bus.emit('connected', _this.id);
            if (options.debug) {
              console.log('Wave connected.');
            }
            return;
          }
          (_a = _this.listeners[message.event]) === null || _a === void 0 ? void 0 : _a.forEach(function (listener) {
            return listener(_extends({}, message));
          });
        },
        onclose: function onclose() {
          if (_this.ctrl.signal.aborted || !reconnect) {
            if (options.debug) {
              console.log('Wave disconnected.');
            }
            _this.bus.emit('close');
            return;
          }
          // if the server closes the connection unexpectedly, retry:
          throw new RetriableError();
        },
        onerror: function onerror(err) {
          if (err instanceof FatalError || 'matcherResult' in err) {
            throw err; // rethrow to stop the operation
          } else {
            // do nothing to automatically retry. You can also
            // return a specific retry interval here.
            _this.reconnecting = true;
            _this.id = undefined;
            _this.bus.emit('reconnect');
            if (options.debug) {
              console.log('Wave reconnecting...');
            }
          }
        }
      }));
    }
  }, {
    key: "getId",
    value: function getId() {
      return this.id;
    }
  }, {
    key: "getSourcePromise",
    value: function getSourcePromise() {
      return this.sourcePromise;
    }
  }, {
    key: "subscribe",
    value: function subscribe(event, callback) {
      var listener = function listener(event) {
        callback(JSON.parse(event.data));
      };
      if (!this.listeners[event]) {
        this.listeners[event] = new Map();
      }
      this.listeners[event].set(callback, listener);
    }
  }, {
    key: "unsubscribe",
    value: function unsubscribe(event) {
      delete this.listeners[event];
    }
  }, {
    key: "removeListener",
    value: function removeListener(event, callback) {
      if (!this.listeners[event] || !this.listeners[event].has(callback)) {
        return;
      }
      this.listeners[event]["delete"](callback);
      if (this.listeners[event].size === 0) {
        delete this.listeners[event];
      }
    }
  }, {
    key: "disconnect",
    value: function disconnect() {
      this.ctrl.abort('disconnect');
    }
  }, {
    key: "on",
    value: function on(event, callback) {
      this.bus.on(event, callback);
    }
  }, {
    key: "off",
    value: function off(event, callback) {
      this.bus.off(event, callback);
    }
  }, {
    key: "once",
    value: function once(event, callback) {
      this.bus.once(event, callback);
    }
  }]);
  return EventSourceConnection;
}();
function debugEvent(message) {
  var data = message.data;
  try {
    // Attempt to parse as JSON
    var parsedData = JSON.parse(data);
    // If successful, replace the data with the stringified parsed data
    data = JSON.stringify(parsedData, null, 2);
  } catch (error) {
    // If it's not valid JSON, just leave the data as it is
  }
  var now = new Date();
  var hours = String(now.getHours()).padStart(2, '0');
  var minutes = String(now.getMinutes()).padStart(2, '0');
  var seconds = String(now.getSeconds()).padStart(2, '0');
  console.group("Received server event ".concat(hours, ":").concat(minutes, ":").concat(seconds));
  console.table(_defineProperty({}, message.id, {
    event: message.event,
    data: data,
    retry: message.retry
  }));
  console.log('Parsed data', JSON.parse(message.data));
  console.groupEnd();
}

var AuthRequestError = /*#__PURE__*/function (_Error) {
  _inherits(AuthRequestError, _Error);
  var _super = _createSuper(AuthRequestError);
  function AuthRequestError(message, response) {
    var _this;
    _classCallCheck(this, AuthRequestError);
    _this = _super.call(this, message);
    _this.name = 'AuthRequestError';
    _this.response = response;
    return _this;
  }
  return _createClass(AuthRequestError);
}( /*#__PURE__*/_wrapNativeSuper(Error));
function authRequest(channel, connection, options) {
  return request(connection).post(options.authEndpoint, options, {
    channel_name: channel
  }).then(function (response) {
    if (!response.ok) {
      throw new AuthRequestError("Auth request to failed with status ".concat(response.status), response);
    }
    return response;
  });
}

var authMethods = ['created', 'updated', 'deleted', 'restored', 'trashed', 'stopListening', 'notification', 'stopListeningNotification'];
var WaveModel = /*#__PURE__*/function () {
  function WaveModel(name, key, connection, options) {
    var _this = this;
    _classCallCheck(this, WaveModel);
    this.callbackMap = new Map();
    this.notificationCallbacks = {};
    this.name = name;
    this.key = key;
    this.connection = connection;
    this.options = options;
    var channelName = "".concat(this.options.namespace, ".").concat(this.name, ".").concat(this.key);
    this.auth = authRequest(channelName, connection, this.options);
    this.channel = "private-".concat(channelName);
    var eventHandlerProxy = new Proxy(this, {
      get: function get(target, prop, receiver) {
        var value = Reflect.get(target, prop, receiver);
        if (authMethods.includes(prop)) {
          return function () {
            for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
              args[_key] = arguments[_key];
            }
            _this.auth.then(function () {
              return value.apply(_this, args);
            });
            return eventHandlerProxy;
          };
        }
        return value;
      }
    });
    var notificationsListener = function notificationsListener(data) {
      if (_this.notificationCallbacks[data.type]) {
        _this.notificationCallbacks[data.type].forEach(function (callback) {
          return callback(data);
        });
      }
    };
    this.connection.subscribe("".concat(this.channel, ".Illuminate\\Notifications\\Events\\BroadcastNotificationCreated"), notificationsListener);
    return eventHandlerProxy;
  }
  _createClass(WaveModel, [{
    key: "listenEvent",
    value: function listenEvent(model, event, callback) {
      var eventName = typeof event === 'string' ? event[0].toUpperCase() + event.slice(1) : model[0].toUpperCase() + model.slice(1);
      var listener = function listener(data) {
        typeof event === 'function' ? event(data.model) : callback(data.model);
      };
      this.callbackMap.set(typeof event === 'string' ? callback : event, listener);
      var modelClass = typeof event === 'string' ? model : this.name;
      this.connection.subscribe("".concat(this.channel, ".").concat(modelClass).concat(eventName), listener);
      return this;
    }
  }, {
    key: "created",
    value: function created(model, callback) {
      if (typeof model === 'function') {
        return this.listenEvent('created', model);
      }
      return this.listenEvent(model, 'created', callback);
    }
  }, {
    key: "updated",
    value: function updated(model, callback) {
      if (typeof model === 'function') {
        return this.listenEvent('updated', model);
      }
      return this.listenEvent(model, 'updated', callback);
    }
  }, {
    key: "deleted",
    value: function deleted(model, callback) {
      if (typeof model === 'function') {
        return this.listenEvent('deleted', model);
      }
      return this.listenEvent(model, 'deleted', callback);
    }
  }, {
    key: "restored",
    value: function restored(model, callback) {
      if (typeof model === 'function') {
        return this.listenEvent('restored', model);
      }
      return this.listenEvent(model, 'restored', callback);
    }
  }, {
    key: "trashed",
    value: function trashed(model, callback) {
      if (typeof model === 'function') {
        return this.listenEvent('trashed', model);
      }
      return this.listenEvent(model, 'trashed', callback);
    }
  }, {
    key: "stopListening",
    value: function stopListening(model, event, callback) {
      var eventName = typeof event !== 'function' ? event[0].toUpperCase() + event.slice(1) : model[0].toUpperCase() + model.slice(1);
      var modelClass = typeof event === 'function' ? this.name : model;
      this.connection.removeListener("".concat(this.channel, ".").concat(modelClass).concat(eventName), this.callbackMap.get(typeof event === 'function' ? event : callback));
      return this;
    }
  }, {
    key: "notification",
    value: function notification(type, callback) {
      if (!this.notificationCallbacks[type]) {
        this.notificationCallbacks[type] = new Set();
      }
      this.notificationCallbacks[type].add(callback);
      return this;
    }
  }, {
    key: "stopListeningNotification",
    value: function stopListeningNotification(type, callback) {
      this.notificationCallbacks[type]["delete"](callback);
      return this;
    }
  }]);
  return WaveModel;
}();

var Wave = /*#__PURE__*/function () {
  function Wave(options) {
    _classCallCheck(this, Wave);
    this.models = {};
    this.options = {
      endpoint: '/wave',
      namespace: 'App.Models',
      auth: {
        headers: {}
      },
      authEndpoint: '/broadcasting/auth'
    };
    this.options = _extends(_extends({}, this.options), options);
    this.connection = new EventSourceConnection(this.options.endpoint, this.options);
  }
  _createClass(Wave, [{
    key: "model",
    value: function model(_model, key) {
      var index = "".concat(_model, ".").concat(String(key));
      if (!this.models[index]) {
        this.models[index] = new WaveModel(_model, key, this.connection, this.options);
      }
      return this.models[index];
    }
  }]);
  return Wave;
}();

var WaveChannel = /*#__PURE__*/function (_Channel) {
  _inherits(WaveChannel, _Channel);
  var _super = _createSuper(WaveChannel);
  /**
   * Create a new class instance.
   */
  function WaveChannel(connection, name, options) {
    var _this;
    _classCallCheck(this, WaveChannel);
    _this = _super.call(this);
    /**
     * The event callbacks applied to the channel.
     */
    _this.events = [];
    /**
     * The event callbacks applied to the channel.
     */
    _this.name = name;
    _this.connection = connection;
    _this.options = options;
    _this.eventFormatter = new laravelEcho.EventFormatter(_this.options.namespace);
    return _this;
  }
  /**
   * Listen for an event on the channel instance.
   */
  _createClass(WaveChannel, [{
    key: "listen",
    value: function listen(event, callback) {
      this.on(this.eventFormatter.format(event), callback);
      return this;
    }
    /**
     * Stop listening for an event on the channel instance.
     */
  }, {
    key: "stopListening",
    value: function stopListening(event) {
      var name = this.eventFormatter.format(event);
      this.connection.unsubscribe("".concat(this.name, ".").concat(name));
      this.events = this.events.filter(function (e) {
        return e !== name;
      });
      return this;
    }
    /**
     * Bind the channel's socket to an event and store the callback.
     */
  }, {
    key: "on",
    value: function on(event, callback) {
      if (!this.events.find(function (e) {
        return e === event;
      })) {
        this.events.push(event);
      }
      this.connection.subscribe("".concat(this.name, ".").concat(event), callback);
      return this;
    }
  }, {
    key: "subscribe",
    value: function subscribe() {
      return;
    }
  }, {
    key: "unsubscribe",
    value: function unsubscribe() {
      var _this2 = this;
      this.events.forEach(function (event) {
        _this2.connection.unsubscribe("".concat(_this2.name, ".").concat(event));
      });
      this.events = [];
    }
  }, {
    key: "subscribed",
    value: function subscribed(callback) {
      this.connection.on('connected', callback);
      return this;
    }
  }, {
    key: "error",
    value: function error(callback) {
      return callback();
    }
  }]);
  return WaveChannel;
}(laravelEcho.Channel);

var WavePrivateChannel = /*#__PURE__*/function (_WaveChannel) {
  _inherits(WavePrivateChannel, _WaveChannel);
  var _super = _createSuper(WavePrivateChannel);
  function WavePrivateChannel(connection, name, options) {
    var _this;
    _classCallCheck(this, WavePrivateChannel);
    _this = _super.call(this, connection, name, options);
    _this.whisperCallbacks = new Map();
    _this.errorCallbacks = [];
    _this.subscribe();
    return _this;
  }
  _createClass(WavePrivateChannel, [{
    key: "subscribe",
    value: function subscribe() {
      var _this2 = this;
      _get(_getPrototypeOf(WavePrivateChannel.prototype), "subscribe", this).call(this);
      this.auth = authRequest(this.name, this.connection, this.options);
      this.auth["catch"](function (error) {
        return _this2.errorCallbacks.forEach(function (callback) {
          return callback(error);
        });
      });
    }
  }, {
    key: "whisper",
    value: function whisper(eventName, data) {
      var _this3 = this;
      request(this.connection).post(this.options.endpoint + '/whisper', this.options, {
        channel_name: this.name,
        event_name: eventName,
        data: data
      })["catch"](function (error) {
        return _this3.errorCallbacks.forEach(function (callback) {
          return callback(error);
        });
      });
      return this;
    }
  }, {
    key: "listenForWhisper",
    value: function listenForWhisper(event, callback) {
      var listener = function listener(data) {
        callback(Array.isArray(data) && data.length === 1 && _typeof(data[0]) !== 'object' ? data[0] : data);
      };
      this.whisperCallbacks.set(callback, listener);
      _get(_getPrototypeOf(WavePrivateChannel.prototype), "listenForWhisper", this).call(this, event, listener);
      return this;
    }
  }, {
    key: "stopListeningForWhisper",
    value: function stopListeningForWhisper(event, callback) {
      if (callback) {
        callback = this.whisperCallbacks.get(callback);
        this.whisperCallbacks["delete"](callback);
      }
      _get(_getPrototypeOf(WavePrivateChannel.prototype), "stopListeningForWhisper", this).call(this, event, callback);
      return this;
    }
  }, {
    key: "on",
    value: function on(event, callback) {
      var _this4 = this;
      this.auth.then(function () {
        return _get(_getPrototypeOf(WavePrivateChannel.prototype), "on", _this4).call(_this4, event, callback);
      });
      return this;
    }
  }, {
    key: "error",
    value: function error(callback) {
      this.errorCallbacks.push(callback);
      return this;
    }
  }]);
  return WavePrivateChannel;
}(WaveChannel);

var WavePresenceChannel = /*#__PURE__*/function (_WavePrivateChannel) {
  _inherits(WavePresenceChannel, _WavePrivateChannel);
  var _super = _createSuper(WavePresenceChannel);
  function WavePresenceChannel(connection, name, options) {
    var _this;
    _classCallCheck(this, WavePresenceChannel);
    _this = _super.call(this, connection, name, options);
    _this.joined = false;
    _this.users = [];
    _this.hereCallbacks = [];
    _this.unloadCallback = _this.unsubscribeBeacon.bind(_assertThisInitialized(_this));
    if (typeof window !== 'undefined') {
      window.addEventListener('beforeunload', _this.unloadCallback);
    }
    return _this;
  }
  _createClass(WavePresenceChannel, [{
    key: "subscribe",
    value: function subscribe() {
      var _this2 = this;
      _get(_getPrototypeOf(WavePresenceChannel.prototype), "subscribe", this).call(this);
      this.joinRequest = authRequest(this.name, this.connection, _extends(_extends({}, this.options), {
        authEndpoint: this.options.endpoint + '/presence-channel-users'
      })).then(function (response) {
        return __awaiter(_this2, void 0, void 0, /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
          var data;
          return _regeneratorRuntime().wrap(function _callee$(_context) {
            while (1) switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return response.json();
              case 2:
                data = _context.sent;
                this.csrfToken = data._token;
                this.users = data.users;
                return _context.abrupt("return", response);
              case 6:
              case "end":
                return _context.stop();
            }
          }, _callee, this);
        }));
      }).then(function (response) {
        _this2.joined = true;
        return response;
      }).then(function (response) {
        _this2.hereCallbacks.forEach(function (callback) {
          return callback(_this2.users);
        });
        _this2.hereCallbacks = [];
        return response;
      });
      this.joinRequest["catch"](function (error) {
        _this2.errorCallbacks.forEach(function (callback) {
          return callback(error);
        });
      });
    }
  }, {
    key: "here",
    value: function here(callback) {
      var _this3 = this;
      if (this.joined) {
        request(this.connection).get(this.options.endpoint + '/presence-channel-users', this.options, {
          channel_name: this.name
        }).then(function (response) {
          return __awaiter(_this3, void 0, void 0, /*#__PURE__*/_regeneratorRuntime().mark(function _callee2() {
            return _regeneratorRuntime().wrap(function _callee2$(_context2) {
              while (1) switch (_context2.prev = _context2.next) {
                case 0:
                  _context2.t0 = callback;
                  _context2.next = 3;
                  return response.json();
                case 3:
                  _context2.t1 = _context2.sent;
                  return _context2.abrupt("return", (0, _context2.t0)(_context2.t1));
                case 5:
                case "end":
                  return _context2.stop();
              }
            }, _callee2);
          }));
        })["catch"](function (error) {
          return _this3.errorCallbacks.forEach(function (callback) {
            return callback(error);
          });
        });
        return this;
      }
      this.hereCallbacks.push(function () {
        return callback(_this3.users);
      });
      return this;
    }
    /**
     * Listen for someone joining the channel.
     */
  }, {
    key: "joining",
    value: function joining(callback) {
      this.listen('.join', callback);
      return this;
    }
    /**
     * Listen for someone leaving the channel.
     */
  }, {
    key: "leaving",
    value: function leaving(callback) {
      this.listen('.leave', callback);
      return this;
    }
  }, {
    key: "unsubscribeBeacon",
    value: function unsubscribeBeacon() {
      beacon(this.connection.getId(), this.csrfToken, this.options.endpoint + '/presence-channel-users', {
        channel_name: this.name
      }, 'DELETE');
      _get(_getPrototypeOf(WavePresenceChannel.prototype), "unsubscribe", this).call(this);
    }
  }, {
    key: "unsubscribe",
    value: function unsubscribe() {
      var _this4 = this;
      this.joinRequest.then(function () {
        request(_this4.connection, true)["delete"](_this4.options.endpoint + '/presence-channel-users', _this4.options, {
          channel_name: _this4.name
        }).then(function () {
          _get(_getPrototypeOf(WavePresenceChannel.prototype), "unsubscribe", _this4).call(_this4);
          if (typeof window !== 'undefined') {
            window.removeEventListener('beforeunload', _this4.unloadCallback);
          }
        })["catch"](function (error) {
          _this4.errorCallbacks.forEach(function (callback) {
            return callback(error);
          });
        });
      });
    }
  }]);
  return WavePresenceChannel;
}(WavePrivateChannel);

var WaveConnector = /*#__PURE__*/function (_Connector) {
  _inherits(WaveConnector, _Connector);
  var _super = _createSuper(WaveConnector);
  function WaveConnector(options) {
    var _this;
    _classCallCheck(this, WaveConnector);
    _this = _super.call(this, _extends({
      endpoint: '/wave'
    }, options));
    _this.channels = {};
    return _this;
  }
  _createClass(WaveConnector, [{
    key: "connect",
    value: function connect() {
      var _this2 = this;
      this.connection = new EventSourceConnection(this.options.endpoint, this.options);
      this.connection.on('reconnect', function () {
        for (var name in _this2.channels) {
          _this2.channels[name].subscribe();
        }
      });
    }
  }, {
    key: "channel",
    value: function channel(_channel) {
      if (!this.channels[_channel]) {
        this.channels[_channel] = new WaveChannel(this.connection, _channel, this.options);
      }
      return this.channels[_channel];
    }
  }, {
    key: "presenceChannel",
    value: function presenceChannel(channel) {
      if (!this.channels['presence-' + channel]) {
        this.channels['presence-' + channel] = new WavePresenceChannel(this.connection, 'presence-' + channel, this.options);
      }
      return this.channels['presence-' + channel];
    }
  }, {
    key: "privateChannel",
    value: function privateChannel(channel) {
      if (!this.channels['private-' + channel]) {
        this.channels['private-' + channel] = new WavePrivateChannel(this.connection, 'private-' + channel, this.options);
      }
      return this.channels['private-' + channel];
    }
  }, {
    key: "disconnect",
    value: function disconnect() {
      this.connection.disconnect();
    }
  }, {
    key: "leave",
    value: function leave(channel) {
      var _this3 = this;
      var channels = [channel, 'private-' + channel, 'presence-' + channel];
      channels.forEach(function (name) {
        _this3.leaveChannel(name);
      });
    }
    /**
     * Leave the given channel.
     */
  }, {
    key: "leaveChannel",
    value: function leaveChannel(channel) {
      if (this.channels[channel]) {
        this.channels[channel].unsubscribe();
        delete this.channels[channel];
      }
    }
  }, {
    key: "socketId",
    value: function socketId() {
      return this.connection.getId();
    }
  }]);
  return WaveConnector;
}(laravelEcho.Connector);

exports.Wave = Wave;
exports.WaveConnector = WaveConnector;
