import WaveChannel from './wave-channel';
export default class WavePrivateChannel extends WaveChannel {
    protected whisperCallbacks: Map<Function, Function>;
    protected auth: Promise<Response>;
    protected errorCallbacks: Function[];
    constructor(connection: any, name: any, options: any);
    subscribe(): void;
    whisper(eventName: any, data: any): this;
    listenForWhisper(event: string, callback: Function): WavePrivateChannel;
    stopListeningForWhisper(event: string, callback?: Function): WavePrivateChannel;
    on(event: string, callback: Function): WavePrivateChannel;
    error(callback: Function): WaveChannel;
}
